#include <bits/stdc++.h>
using namespace std;

const int maxn = 1000 + 10;
const int dx[3] = {-1,0,1},dy[3] = {0,1,0};

int n,m;
int g[maxn][maxn];
long long ans,f[maxn][maxn];
bool mark[maxn][maxn],mark2[maxn][maxn];

void dfs2(int x,int y,int now)
{
	if(mark2[x][y] && now < f[x][y]) return;
	f[x][y] = now,mark2[x][y] = 1;
	for(int i = 0;i < 3;i++)
	{
		int tx = x + dx[i],ty = y + dy[i];
		if(mark[tx][ty] || tx < 1 || tx > n || ty < 1 || ty > m) continue;
		mark[tx][ty] = 1;
		dfs2(tx,ty,now + g[tx][ty]);
		mark[tx][ty] = 0;
	}
}

void dfs(int x,int y,int now)
{
	if(x == n && y == m) ans = now > ans ? now : ans;
	for(int i = 0;i < 3;i++)
	{
		int tx = x + dx[i],ty = y + dy[i];
		if(mark[tx][ty] || tx < 1 || tx > n || ty < 1 || ty > m) continue;
		mark[tx][ty] = 1;
		dfs(tx,ty,now + g[tx][ty]);
		mark[tx][ty] = 0;
	}
}

int main()
{
	freopen("number.in","r",stdin);
	freopen("number.out","w",stdout);
	scanf("%d%d",&n,&m);
	for(int i = 1;i <= n;i++)
		for(int j = 1;j <= m;j++)
			scanf("%d",&g[i][j]);
	if(n <= 10 && m <= 10)
	{
		ans = -(1 << 30);
		mark[1][1] = 1;
		dfs(1,1,g[1][1]);
		printf("%d",ans);
	}
	else
	{
		dfs2(1,1,g[1][1]);
		printf("%d",f[n][m]);
	}
	fclose(stdin);
	fclose(stdout);
	return 0;
}
