#include <bits/stdc++.h>
using namespace std;
bool vis[1005][1005];
int n,m,a[1005][1005];
int dx[5]={0,0,-1,1},dy[5]={-1,1,0,0};
long long ans=-1e18;
struct node{
	int i,j;
	long long w;
	node(int ii,int jj,long long ww){
		i=ii,j=jj,w=ww;
	}
	bool operator <(const node &a1) const{
		return w>a1.w;
	}
};
bool visi[1005*1005];
long long dis[1005*1005];

inline void dfs(int x,int y,long long w){
	if(x==n&&y==m){
		ans=max(ans,w+a[x][y]);
		return;
	}
	vis[x][y]=1;
	for(int i=0;i<4;i++){
		int tx=x+dx[i],ty=y+dy[i];
		if(tx<=0||tx>n||ty<=0||ty>m||vis[tx][ty])
			continue;
		dfs(tx,ty,w+a[x][y]);
	}
	vis[x][y]=0;
}

void dijkstra(){
	priority_queue<node> q;
	for(int i=1;i<=n;i++)
		for(int j=1;j<=m;j++)
			dis[(i-1)*m+j]=-1e18;
	q.push(node(1,1,dis[1]=0));
	memset(visi,0,sizeof(visi));
	while(!q.empty()){
		node k=q.top();q.pop();
		if(visi[(k.i-1)*m+k.j])continue;visi[(k.i-1)*m+k.j]=1;
		int s[5]={0,1,2,3};random_shuffle(s,s+4);
		for(int i=0;i<4;i++){
			int tx=k.i+dx[s[i]],ty=k.j+dy[s[i]],iid=(tx-1)*m+ty;
			if(tx<=0||tx>n||ty<=0||ty>m)continue;
			if(dis[iid]<dis[(k.i-1)*m+k.j]+a[tx][ty])
				dis[iid]=dis[(k.i-1)*m+k.j]+a[tx][ty],q.push(node(tx,ty,dis[iid]));
		}	
	}
}

int main(){
	srand(time(NULL));
	freopen("number.in","r",stdin);
	freopen("number.out","w",stdout);
	scanf("%d%d",&n,&m);
	for(int i=1;i<=n;i++)
		for(int j=1;j<=m;j++)
			scanf("%d",&a[i][j]);
	if(n<=50&&m<=50){
		dfs(1,1,0);
		printf("%lld\n",ans);
		return 0;
	}
	dijkstra();
	printf("%lld\n",dis[(n-1)*m+m]);
	return 0;
} 
