// C++ includes used for precompiling -*- C++ -*-

// Copyright (C) 2003-2013 Free Software Foundation, Inc.
//
// This file is part of the GNU ISO C++ Library.  This library is free
// software; you can redistribute it and/or modify it under the
// terms of the GNU General Public License as published by the
// Free Software Foundation; either version 3, or (at your option)
// any later version.

// This library is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.

// Under Section 7 of GPL version 3, you are granted additional
// permissions described in the GCC Runtime Library Exception, version
// 3.1, as published by the Free Software Foundation.

// You should have received a copy of the GNU General Public License and
// a copy of the GCC Runtime Library Exception along with this program;
// see the files COPYING3 and COPYING.RUNTIME respectively.  If not, see
// <http://www.gnu.org/licenses/>.

/** @file stdc++.h
 *  This is an implementation file for a precompiled header.
 */

// 17.4.1.2 Headers

// C
#ifndef _GLIBCXX_NO_ASSERT
#include <cassert>
#endif
#include <cctype>
#include <cerrno>
#include <cfloat>
#include <ciso646>
#include <climits>
#include <clocale>
#include <cmath>
#include <csetjmp>
#include <csignal>
#include <cstdarg>
#include <cstddef>
#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <ctime>

#if __cplusplus >= 201103L
#include <ccomplex>
#include <cfenv>
#include <cinttypes>
#include <cstdalign>
#include <cstdbool>
#include <cstdint>
#include <ctgmath>
#include <cwchar>
#include <cwctype>
#endif

// C++
#include <algorithm>
#include <bitset>
#include <complex>
#include <deque>
#include <exception>
#include <fstream>
#include <functional>
#include <iomanip>
#include <ios>
#include <iosfwd>
#include <iostream>
#include <istream>
#include <iterator>
#include <limits>
#include <list>
#include <locale>
#include <map>
#include <memory>
#include <new>
#include <numeric>
#include <ostream>
#include <queue>
#include <set>
#include <sstream>
#include <stack>
#include <stdexcept>
#include <streambuf>
#include <string>
#include <typeinfo>
#include <utility>
#include <valarray>
#include <vector>

#if __cplusplus >= 201103L
#include <array>
#include <atomic>
#include <chrono>
#include <condition_variable>
#include <forward_list>
#include <future>
#include <initializer_list>
#include <mutex>
#include <random>
#include <ratio>
#include <regex>
#include <scoped_allocator>
#include <system_error>
#include <thread>
#include <tuple>
#include <typeindex>
#include <type_traits>
#include <unordered_map>
#include <unordered_set>
#endif
#define rep(x,l,r) for(register ll x=l;x<=r;++x)
#define per(x,l,r) for(register ll x=l;x>=r;--x)
#define max(a,b) std::max(ll(a),ll(b))
#define min(a,b) std::min(ll(a),ll(b))
#define IO(x) freopen(#x".in","r",stdin),freopen(#x".out","w",stdout);
typedef long long ll;
ll readll(void){
	ll x=0,w=1;
	char c=getchar();
	for(;c<'0'||c>'9';c-'-'||(w=-w),c=getchar());
	for(;c>='0'&&c<='9';x=x*10+(c^48),c=getchar());
	return x*w;
}
//void link(ll u,ll v){
//	nxt[u]=v;
//	pre[v]=u;
//}
ll f[777];
#define lowbit(x) ((x)&-(x))
void add(ll u){
	u=650-u;
	while(u<=650)++f[u],u+=lowbit(u);
}
ll query(ll rk){
	ll u=0,sum=0,i=512;
	while(i)u+i<=650&&sum+f[u+i]<rk&&(sum+=f[u+=i]),i>>=1;
	return 649-u;
}
int main(){
	IO(live);
	ll n=readll(),w=readll(),k=1;
	rep(i,1,n){
		if(k<i*w/100)k++;
		add(readll());
		printf("%lld ",query(k));
	}
//	rep(i,1,n){
//		a[i]=readll();
//		t[a[i]]++;
//	}
//	ll last=-1;
//	rep(i,0,600)
//	if(t[i]){
//		link(last,i);
//		last=i;
//	}
//	printf("%lld\n",a[1]);
//	ll p=a[1],sum=1;
//	rep(i,2,n){
//		while(sum<w/100*i)
//	}
	return 0;
}
