#include <bits/stdc++.h>

using namespace std;

const int N = 3e5 + 15;
int n, q, res, inputtag, pos[N], a[N], str[N], len;
char ch[30];

inline int read() {
	int res = 0; char ch = getchar();
	bool f = false;
	inputtag = 1;
	for(; ch < '0' || ch > '9'; ch = getchar()) {
		if(ch == '-') f = true;
		else if(ch == '&' || ch == '|' || ch == '!' || ch == 'x') {
			inputtag = 0;
			if(ch == '!') return -1;
			if(ch == '&') return -2;
			if(ch == '|') return -3;
		}
	}
	for(; ch >= '0' && ch <= '9'; ch = getchar())
		res = res * 10 + ch - 48;
	return f ? -res : res;
}

void input() {
	while(1) {
		str[++ len] = read();
		if(inputtag) break;
		if(str[len] >= 1) pos[str[len]] = len;
	}
	n = str[len]; len --;
	for(int i = 1; i <= n; ++ i)
		a[i] = read();
}

namespace sub1 {
	int ans[N], stk[N], top;

	void calc() {
		for(int i = 1; i <= n; ++ i) {
			a[i] ^= 1;
			top = 0;
			for(int j = 1; j <= n; ++ j)
				stk[j] = 0;
			for(int j = 1; j <= len; ++ j) {
				switch(str[j]) {
					case -1 : stk[top] ^= 1; break;
					case -2 : stk[top - 1] &= stk[top]; -- top; break;
					case -3 : stk[top - 1] |= stk[top]; -- top; break;
					default : stk[++ top] = a[str[j]]; break;
				}
			}
			ans[i] = stk[top];
			a[i] ^= 1;
		}
	}

	void solve() {
		int q, x;
		for(q = read(); q; -- q) {
			x = read();
			printf("%d\n", ans[x]);
		}
	}

}

namespace sub2 {
	int root, ans[N][2], lc[N], rc[N], sum[N], stk[N], top;

	void add(int ch, int fa) {
		if(lc[fa]) rc[fa] = ch;
		else lc[fa] = ch;
	}

	void build() {
		for(int j = 1; j <= len; ++ j) {
			switch(str[j]) {
				case -1 : add(stk[top], j); stk[top] = j; break;
				case -2 : add(stk[top], j); add(stk[top - 1], j); stk[-- top] = j; break;
				case -3 : add(stk[top], j); add(stk[top - 1], j); stk[-- top] = j; break;
				default : stk[++ top] = j; break;
			}
		}
		for(int i = len; i >= 1; -- i)
			if(str[i] < 0) {
				root = i;
				break;
			}
	}

	void dfs1(int u) {
		if(lc[u]) dfs1(lc[u]);
		if(rc[u]) dfs1(rc[u]);
		switch(str[u]) {
			case -1 : sum[u] = sum[lc[u]] ^ 1; break;
			case -2 : sum[u] = sum[lc[u]] & sum[rc[u]]; break;
			case -3 : sum[u] = sum[lc[u]] | sum[rc[u]]; break;
			default : sum[u] = a[str[u]]; break;
		}
	}

	void dfs2(int u, int t) {
		if(str[u] > 0) {
			if(t < 2) ans[u][t] = 1;
			else ans[u][0] = ans[u][1] = 1;
		} else {
			if(str[u] == -1) {
				if(t < 2) dfs2(lc[u], t ^ 1);
				else dfs2(lc[u], t);
			} else if(str[u] == -2) {
				if(t == 2) dfs2(lc[u], 2), dfs2(rc[u], 2);
				else if(t == 1) {
					if(sum[lc[u]]) dfs2(rc[u], 1);
					if(sum[rc[u]]) dfs2(lc[u], 1);
				} else {
					dfs2(lc[u], (sum[rc[u]] == 1 ? 0 : 2));
					dfs2(rc[u], (sum[lc[u]] == 1 ? 0 : 2));
				}
			} else {
				if(t == 2) dfs2(lc[u], 2), dfs2(rc[u], 2);
				else if(t == 1) {
					dfs2(lc[u], (sum[rc[u]] == 1 ? 2 : 1));
					dfs2(rc[u], (sum[lc[u]] == 1 ? 2 : 1));
				} else {
					if(!sum[lc[u]]) dfs2(rc[u], 0);
					if(!sum[rc[u]]) dfs2(lc[u], 0);
				}
			}
		}
	}

	void solve() {
		int q, x;
		for(q = read(); q; -- q) {
			x = read();
			printf("%d\n", ans[pos[x]][a[x] ^ 1]);
		}
	}

}

signed main() {
	freopen("expr.in", "r", stdin);
	freopen("expr.out", "w", stdout);
	input();
	if(n <= 1000) {
		sub1 :: calc();
		sub1 :: solve();
	} else {
		sub2 :: build();
		sub2 :: dfs1(sub2 :: root);
		sub2 :: dfs2(sub2 :: root, 1);
		sub2 :: solve();
	}
	return 0;
}
