#include<bits/stdc++.h>
using namespace std;
const int maxn=1e6+50;
struct point
{
	bool item;
	bool leaf;
	char op;
	int xi;
	
	int rt;
	int lson;
	int rson;
	
}p[maxn];

int cnt=0;
string a[maxn];
int n;
int f[maxn];


inline void cut(){printf("------------------------------------------\n");}
inline void debug(int k)
{
	if(k==1)
	{
		cut();
		for(register int i=1;i<=cnt;++i)
		{
			cout<<a[i]<<"\n";
		}
		cut();
	}
	if(k==2)
	{
		int maxrt=pow(2,log(cnt)/log(2)+3);
		for(register int i=1;i<=maxrt;++i)
		 if(p[i].item) printf("[%d] op = %c xi = %d lson = %d rson = %d\n",i,p[i].op,p[i].xi,(i<<1),(i<<1|1));
	}
}
inline void read()
{
	string st;
	getline(cin,st);
	int len=st.length();
	string now="";
	for(register int i=0;i<len;++i)
	{
		if(st[i]==' ')
		{
			a[++cnt]=now;
			now="";
		}
		else now=now+st[i];
	}
	a[++cnt]=now;
	
//	debug(1);
	
	scanf("%d",&n);
	for(register int i=1;i<=n;++i) scanf("%d",&f[i]);
}
inline void build(int rt,int l,int r)
{
	if(a[r][0]!='x')
	{
		p[rt].item=true;
		p[rt].op=a[r][0];
	}
	else
	{
		p[rt].item=true;
		int k=0;
		for(register int i=1;i<a[r].length();++i) k=k*10+(a[r][i]-'0');
		p[rt].xi=k;
	}
	if(l==r) 
	{
		p[rt].leaf=1;
		return ;
	}
	int lson=rt<<1;
	int rson=rt<<1|1;
	int left=0,right=0;
	if(p[rt].op=='!')
	{
	//	printf("[rt = %d]: ! r-1 = %d\n",rt,r-1);
		build(lson,l,r-1);
		return;
	}
	
	for(register int i=l;i<r;++i)
	  if(a[i][0]!='x')
	  {
	  	 left=i;
	  	 break;
	  }
	for(register int i=r-1;i>=l;--i)
	  if(a[i][0]!='x')
	  {
	  	right=i;
	  	break;
	  }
//	printf("[rt = %d]: OP left = %d right = %d\n",rt,left,right);
	if(left==right&&left==0)
	{
		build(lson,r-2,r-2);
		build(rson,r-1,r-1);
	}
	else
	if(left==right)
	{
		if(left==r-1)
		{
			build(lson,l,l);
			build(rson,l+1,r-1);
		}
		else
		{
			build(rson,r-1,r-1);
			build(lson,l,r-2);
		}
	}
	else
	{
		build(lson,l,left);
		build(rson,left+1,r-1);
	}
}
inline int query(int rt,int flag)
{
	if(p[rt].xi==flag)	return f[flag]?0:1;
	if(p[rt].leaf) return f[p[rt].xi];
	char op=p[rt].op;
	int lson=(rt<<1),rson=(rt<<1|1);
	if(op=='!') return query(lson,flag)?0:1;
	if(op=='&') return query(lson,flag)&query(rson,flag);
	if(op=='|') return query(lson,flag)|query(rson,flag);
}
int main()
{
	freopen("expr.in","r",stdin);
	freopen("expr.out","w",stdout);
	read();
	build(1,1,cnt);
//	debug(2);
	int T;
	scanf("%d",&T);
	while(T--)
	{
		int flag;scanf("%d",&flag);
		cout<<query(1,flag)<<"\n";
	}
	return 0;
}

