#include <fstream>
#include <deque>
#include <string>

int a[1000001] = {};

int main(int argc, char** argv)
{
	std::ifstream cin("expr.in");
	std::ofstream cout("expr.out");
	
	std::string s;
	std::getline(cin, s);
	
	std::deque<int> n;
	std::deque<char> ope;
	int len = s.length();
	int x = 0;
	for(int i = 0; i < len; i++)
	{
		if(s[i] == 'x')
		{
			continue;
		}
		if(s[i] >= '0' && s[i] <= '9')
		{
			x = (x << 3) + (x << 1) + (s[i] ^ 48);
		}
		if(s[i] == '&' || s[i] == '|')
		{
			n.push_back(x);
			x = 0;
			ope.push_back(s[i]);
		}
	}
	
	int m;
	cin >> m;
	
	for(int i = 1; i <= m; i++)
	{
		cin >> a[i];
	}
	
	int t;
	cin >> t;
	for(int i = 1; i <= t; i++)
	{
		int change;
		cin >> change;
		a[change] = !(a[change]);
		std::deque<int> temp(n);
		std::deque<int> res;
		std::deque<char> op(ope);
		while(!(temp.empty()))
		{
			res.push_back(a[temp.front()]);
			temp.pop_front();
		}
		while(!(op.empty()))
		{
			int first = res.front();
			res.pop_front();
			int second = res.front();
			res.pop_front();
			char c = op.front();
			op.pop_front();
			if(c == '&')
			{
				res.push_back(first && second);
			}
			if(c == '|')
			{
				res.push_back(first || second);
			}
		}
		cout << res.front() << "\n";
		a[change] = !(a[change]);
	}
	
	cin.close();
	cout.close();
	return 0;
}
