#include<cstdio>
#include<cstring>
#define maxn 1039
using namespace std;
//#define debug
typedef int Type;
inline Type read(){
	int flag=0; Type sum=0;
	char c=getchar();
	while((c<'0'||c>'9')&&c!='-') c=getchar();
	if(c=='-') c=getchar(),flag=1;
	while('0'<=c&&c<='9'){
		sum=(sum<<1)+(sum<<3)+(c^48);
		c=getchar();
	}
	if(flag) return -sum;
	return sum;
}
int n,m;
int a[maxn][maxn];
int vis[maxn][maxn];
int px[10]={0,1,0,-1, 0};
int py[10]={0,0,1, 0,-1};
namespace SPFA{
	int dist[maxn][maxn];
	void dfs(int x,int y){
		int tox,toy;
		for(int i=1;i<=4;i++){
			tox=x+px[i];
			toy=y+py[i];
			if(1<=tox&&tox<=n && 1<=toy&&toy<=m && !vis[tox][toy] && dist[x][y]+a[tox][toy]>dist[tox][toy]){
				vis[tox][toy]=1;
				dist[tox][toy]=dist[x][y]+a[tox][toy];
			    dfs(tox,toy);
			    vis[tox][toy]=0;
			}
		}
		return;
	}
}
int maxx;
void dfs(int x,int y,int ans){
	if(x==n&&y==m){
		if(ans>maxx) maxx=ans;
		return;
	}
	int tox,toy;
	for(int i=1;i<=4;i++){
		tox=x+px[i];
		toy=y+py[i];
		if(1<=tox&&tox<=n && 1<=toy&&toy<=m && !vis[tox][toy]){
			vis[tox][toy]=1;
			dfs(tox,toy,ans+a[tox][toy]);
			vis[tox][toy]=0;
	    }
	}
	return;
}
int main(){
	freopen("number.in","r",stdin);
	freopen("number.out","w",stdout);
    n=read(); m=read();
    for(int i=1;i<=n;i++)
        for(int j=1;j<=m;j++)
            a[i][j]=read();
            
    if(m+n<15){
    	maxx=-0x7fffffff;
    	dfs(1,1,a[1][1]);
    	printf("%d",maxx);
	}
	else{
	    memset(SPFA::dist,0xaf,sizeof(SPFA::dist));
		SPFA::dist[1][1]=a[1][1];
		vis[1][1]=1;
		SPFA::dfs(1,1);
	    printf("%d",SPFA::dist[n][m]);
	}
	return 0;
}

