#include <bits/stdc++.h>

using namespace std;

const int N = 3e5 + 10;
string s, w;
int n, a[N], idx(0), inf[N], q, Stack[N], top(0), Start[N], End[N], con[N], cnt(0), res[N];
vector<int> G[N];

inline int tonum();
inline void prework();
void work(int x);
void solve(int x);
int ask(int x, int num);

int main() {
	freopen("expr.in", "r", stdin);
	freopen("expr.out", "w", stdout);
	ios::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	getline(cin, s);
	cin >> n;
	for (int i = 1; i <= n; i++)
		cin >> a[i];
	prework();
	work(idx);
	solve(idx);
	cin >> q;
	while (q--) {
		int x;
		cin >> x;
		cout << ask(idx, x) << '\n';
	}
	
	return 0;
}

inline int tonum() {
	int tot = 0;
	for (int i = 1; i < w.size(); i++)
		tot = tot * 10 + w[i] - '0';
	return tot;
}

inline void prework() {
	s += " ";
	w = ""; 
	for (int i = 0; i < s.size(); i++) {
		if (s[i] == ' ') {
			idx++;
			if (w[0] == 'x') {
				inf[idx] = tonum();
				Stack[++top] = idx;
			} else {
				if (w[0] == '&') inf[idx] = -1;
				else if (w[0] == '|') inf[idx] = -2;
				else if (w[0] == '!') inf[idx] = -3;
				if (inf[idx] > -3) {
					G[idx].push_back(Stack[top--]);
					G[idx].push_back(Stack[top--]);
					Stack[++top] = idx;
				} else {
					G[idx].push_back(Stack[top--]);
					Stack[++top] = idx;
				}
			}
			w = "";
		} else 
			w += s[i];
	}
}

void work(int x) {
	Start[x] = End[x] = ++cnt;
	if (inf[x] > 0)
		con[inf[x]] = cnt;
	for (int i = 0; i < G[x].size(); i++) {
		int y = G[x][i];
		work(y);
		End[x] = End[y];
	}
}

void solve(int x) {
	if (inf[x] > 0)
		res[x] = a[inf[x]];
	else if (inf[x] == -3) {
		solve(G[x][0]);
		res[x] = !res[G[x][0]];
	} else if (inf[x] == -1) {
		solve(G[x][0]);
		solve(G[x][1]);
		res[x] = res[G[x][0]] & res[G[x][1]];
	} else {
		solve(G[x][0]);
		solve(G[x][1]);
		res[x] = res[G[x][0]] | res[G[x][1]];
	}
}

int ask(int x, int num) {
	if (inf[x] > 0)
		return !a[num];
	if (inf[x] == -3)
		return !ask(G[x][0], num);
	int y1 = G[x][0], y2 = G[x][1];
	if (Start[y1] <= con[num] && con[num] <= End[y1]) {
		if (inf[x] == -1) {
			if (res[y2] == 0)
				return 0;
			else
				return ask(y1, num);
		} else {
			if (res[y2] == 1)
				return 1;
			else
				return ask(y1, num);
		}
	} else if (Start[y2] <= con[num] && con[num] <= End[y2]) {
		if (inf[x] == -1) {
			if (res[y1] == 0)
				return 0;
			else
				return ask(y2, num);
		} else {
			if (res[y1] == 1)
				return 1;
			else
				return ask(y2, num);
		}
	}
}
