#include <bits/stdc++.h>
using namespace std;
int n,m,t;
string str;
struct node{
	int pos,oper;//oper:1 stands for !,2 stands for &,3 stands for |
	bool num,leaf;
};
struct tr_node{
	node con;
	int fa,son1,son2;//if this node's operator is '!', then it should only have son1 instead of son2
	bool aff;//it means if it could change the answer if I switch this node's num
}expr[1000005];
void print(){
	printf("i            "); for (register int i = 1; i <= m; i++) printf("%3d ",i); printf("\n");
	printf("e[i].con.leaf"); for (register int i = 1; i <= m; i++) printf("%3d ",expr[i].con.leaf); printf("\n");
	printf("e[i].con.pos "); for (register int i = 1; i <= m; i++) printf("%3d ",expr[i].con.pos); printf("\n");
	printf("e[i].con.oper"); for (register int i = 1; i <= m; i++) printf("%3d ",expr[i].con.oper); printf("\n");
	printf("e[i].con.num "); for (register int i = 1; i <= m; i++) printf("%3d ",expr[i].con.num); printf("\n");
	printf("e[i].fa      "); for (register int i = 1; i <= m; i++) printf("%3d ",expr[i].fa); printf("\n");
	printf("e[i].son1    "); for (register int i = 1; i <= m; i++) printf("%3d ",expr[i].son1); printf("\n");
	printf("e[i].son2    "); for (register int i = 1; i <= m; i++) printf("%3d ",expr[i].son2); printf("\n");
	printf("e[i].aff     "); for (register int i = 1; i <= m; i++) printf("%3d ",expr[i].aff); printf("\n");
}
void procs(){
	int i = 0;
	while (i < str.length()){
		if (str[i] == ' ') str.erase(i,1);
		i++;
	}
	i = 0;
	while (i < str.length()){
		while (i >= 1 && str[i] == '!' && str[i - 1] == '!') str.erase(i - 1,2);
		i++;
	}
	/*test*///cout << str << endl;
	stack<node> myst;
	node now;
	m = n;
	for (register int i = 1; i <= n; i++) expr[i].con.leaf = true,expr[i].con.pos = i;
	for (register int i = 0; i < str.length(); i++){
		if (str[i] == 'x'){
			int s = 0;
			i++;
			while (str[i] >= '0' && str[i] <= '9') s = s * 10 + str[i] - 48,i++;
			i--;
			//printf("%d\n",s);
			now.leaf = true; now.pos = s;
			myst.push(now);
		}
		else {
			if (str[i] == '!'){
				expr[++m].con.leaf = false;
				expr[m].con.oper = 1;
				expr[m].con.pos = m;
				expr[m].son1 = myst.top().pos;
				expr[m].son2 = -1;
				expr[myst.top().pos].fa = m;
				myst.pop();
				now = expr[m].con;
				myst.push(now);
			}
			if (str[i] == '&'){
				expr[++m].con.leaf = false;
				expr[m].con.oper = 2;
				expr[m].con.pos = m;
				expr[m].son2 = myst.top().pos;
				expr[myst.top().pos].fa = m;
				myst.pop();
				expr[m].son1 = myst.top().pos;
				expr[myst.top().pos].fa = m;
				myst.pop();
				now = expr[m].con;
				myst.push(now);
			}
			if (str[i] == '|'){
				expr[++m].con.leaf = false;
				expr[m].con.oper = 3;
				expr[m].con.pos = m;
				expr[m].son2 = myst.top().pos;
				expr[myst.top().pos].fa = m;
				myst.pop();
				expr[m].son1 = myst.top().pos;
				expr[myst.top().pos].fa = m;
				myst.pop();
				now = expr[m].con;
				myst.push(now);
			}
			//print();
		}
	}
}
bool calc(int k){
	if (expr[k].con.leaf) return expr[k].con.num;
	int s1 = expr[k].son1,s2 = expr[k].son2;
	if (expr[k].con.oper == 1) return expr[k].con.num = !calc(s1);
	if (expr[k].con.oper == 2) return expr[k].con.num = calc(s1) && calc(s2);
	if (expr[k].con.oper == 3) return expr[k].con.num = calc(s1) || calc(s2);
}
void affect(int k,bool af){
	int s1 = expr[k].son1,s2 = expr[k].son2;
	//printf("affect(%d,%d)\n",k,af);
	if (!af){
		if (expr[k].con.leaf){
			expr[k].aff = false;
			//printf("r\n");
			return;
		}
		affect(s1,false);
		if (expr[k].con.oper != 1) affect(s2,false);
		//printf("r\n");
		return;
	}
	if (expr[k].con.leaf){
		expr[k].aff = true;
		//printf("r\n");
		return;
	}
	if (expr[k].con.oper == 1) affect(s1,true);
	if (expr[k].con.oper == 2){
		if (expr[s2].con.num == false) affect(s1,false); else affect(s1,true);
		if (expr[s1].con.num == false) affect(s2,false); else affect(s2,true);
	}
	if (expr[k].con.oper == 3){
		if (expr[s2].con.num == false) affect(s1,true); else affect(s1,false);
		if (expr[s1].con.num == false) affect(s2,true); else affect(s2,false);
	}
	//printf("r\n");
	return;
}
int main(){
	freopen("expr.in","r",stdin);
	freopen("expr.out","w",stdout);
	getline(cin,str);
	cin >> n;
	procs();
	for (register int i = 1; i <= n; i++) cin >> expr[i].con.num;
	calc(m);
	affect(m,true);
	//print();
	cin >> t;
	while (t--){
		int x;
		cin >> x;
		printf("%d\n",(expr[m].con.num + expr[x].aff) % 2);
	}
	return 0;
}
