#include <iostream>
#include <cstdio>
#include <cmath>
#include <algorithm>

using namespace std;

const int MAXN = 1e5 + 5;
int NumPlayer;
int PricePercent;
int Score[MAXN];

int max (int x, int y) {
	if (x > y) {
		return x;
	}
	return y;
}

bool cmp (int x, int y) {
	return x > y;
}

int find (int l, int r, int x) {
	if (Score[x] >= Score[l]) return l;
	if (Score[x] <= Score[r]) return r + 1;
	int Mid = (l + r) / 2;
	if (Score[x] >= Score[Mid]) return find (l, Mid, x);
	else return find (Mid + 1, r, x);
}

int main () {
	
	freopen("live.in", "r", stdin);
	freopen("live.out", "w", stdout);

	scanf ("%d %d", &NumPlayer, &PricePercent);
	for (int i = 1; i <= NumPlayer; i ++) {
		scanf ("%d", &Score[i]);
		int x = find (1, i - 1, i);
		int Tmp = Score[i];
		for (int j = i - 1; j >= x; j --) {
			Score[j + 1] = Score[j];
		}
		Score[x] = Tmp;
		int PlanPrice = max (1, (int) (i * PricePercent / 100));
		printf ("%d", Score[PlanPrice]);
		if (i == NumPlayer) {
			printf ("\n");
		}
		else {
			printf (" ");
		}
	}
	
	fclose(stdin);
	fclose(stdout);
	
	return 0;
}
