#include <cstdio>
#include <algorithm>

using namespace std;

int INF = 0x3f3f3f3f;
int maps[1005][1005], vis[1005][1005] = {0}, ans = -INF;
int n, m;
int dir[3][2] = {{1,0},{0,-1},{0,1}};

void dfs(int x, int y, int val){
	
	if (x == n && y == m){
		ans = max(ans, val);
		return ;
	}
	
	for (int i = 0; i < 3; i++){
		
		int tx = x + dir[i][0];
		int ty = y + dir[i][1];
		
		if (tx < 1 || ty < 1 || tx > n || ty > m || vis[tx][ty])
			continue;
		
		vis[tx][ty] = 1;
		dfs(tx, ty, val + maps[tx][ty]);
		vis[tx][ty] = 0;
			
	}
	
}

int main(){
	
	freopen("number.in", "r", stdin);
	freopen("number.out", "w", stdout);
	
	scanf("%d %d", &n, &m);
	for (int i = 1; i <= n; i++)
		for (int j = 1; j <= m; j++)
			scanf("%d", &maps[i][j]);
	dfs(1, 1, maps[1][1]);
	printf("%d\n", ans);
	
	fclose(stdin);
	fclose(stdout);
	
	return 0;
}
