#include<stdio.h>
#include<iostream>
#include<bits/stdc++.h>
using namespace std;
const int Max=1e6+100;
string s;
int mem[Max],root,depth[Max],res[Max];
struct node
{
	char opt;
	bool sum;
	int ls,rs,fa;
}t[Max*2];
int order=0,n;
bool vis[Max];
void init()
{
	stack<int>st;
	int len=s.size();
	for(int i=0;i<len;++i)
	{
		if(s[i]==' ')
			continue;
		if(s[i]=='x')
		{
			int tmp=0;
			++i;
			while(i<len&&s[i]>='0'&&s[i]<='9')
			{
				tmp=tmp*10+s[i]-'0';
				++i;
			}
			++order;
			mem[tmp]=order;
			t[order].sum=false;
			t[order].fa=t[order].ls=t[order].rs=0;
			st.push(order);
			root=order;
		}
		if(s[i]=='!')
		{
			int tmp=st.top();
			st.pop();
			++order;
			t[order].opt='!';
			t[order].fa=t[order].ls=0;
			t[order].rs=tmp;
			t[tmp].fa=order;
			st.push(order);
			root=order;
		}
		if(s[i]=='|')
		{
			++order;
			int t1=st.top();
			st.pop();
			int t2=st.top();
			st.pop();
			++order;
			t[order].opt='|';
			t[order].fa=0;
			t[order].ls=t1;
			t[order].rs=t2;
			t[t1].fa=t[t2].fa=order;
			st.push(order);
			root=order;
		}
		if(s[i]=='&')
		{
			int t1=st.top();
			st.pop();
			int t2=st.top();
			st.pop();
			++order;
			t[order].opt='&';
			t[order].sum=false;
			t[order].fa=0;
			t[order].ls=t1;
			t[order].rs=t2;
			t[t1].fa=t[t2].fa=order;
			st.push(order);
			root=order;
		}
	}
}
struct CSP
{
	int x,dep;
	bool operator <(const CSP &x)const
	{
		return dep<x.dep;
	}
};
void dfs(int x)
{
	int ls=t[x].ls,rs=t[x].rs;
	if(ls)
	{
		depth[ls]=depth[x]+1;
		dfs(ls);
	}
	if(rs)
	{
		depth[rs]=depth[x]+1;
		dfs(rs);
	}
}
void func()
{
	depth[root]=1;
	dfs(root);
	priority_queue<CSP>q;
	for(int i=1;i<=n;++i)
	{
		int tmp=t[mem[i]].fa;
		if(vis[tmp]||tmp==0)
			continue;
		vis[tmp]=true;
		CSP k;
		k.dep=depth[tmp];
		k.x=tmp;
		q.push(k);
	}
	while(!q.empty())
	{
		CSP A=q.top();
		int p=A.x;
		q.pop();
		char opt=t[p].opt;
		int ls=t[p].ls,rs=t[p].rs;
		if(opt=='!')
			t[p].sum=(!t[rs].sum);
		if(opt=='|')
			t[p].sum=(t[ls].sum||t[rs].sum);
		if(opt=='&')
			t[p].sum=(t[ls].sum&&t[rs].sum);
		int fa=t[p].fa;
		if(vis[fa]||fa==0)
			continue;
		vis[fa]=true;
		CSP k;
		k.dep=depth[fa];
		k.x=fa;
		q.push(k);
	}
}
void update(int x)
{
	t[x].sum=(!t[x].sum);
	int p=t[x].fa;
	while(p)
	{
		int opt=t[p].opt;
		int ls=t[p].ls,rs=t[p].rs;
		if(opt=='!')
			t[p].sum=(!t[rs].sum);
		if(opt=='|')
			t[p].sum=(t[ls].sum||t[rs].sum);
		if(opt=='&')
			t[p].sum=(t[ls].sum&&t[rs].sum);
		p=t[p].fa;
	}
}
int main()
{
	freopen("expr.in","r",stdin);
	freopen("expr.out","w",stdout);
	getline(cin,s);
	s=" "+s+" ";
	init();
	scanf("%d",&n);
	for(int i=1;i<=n;++i)
	{
		int x;
		scanf("%d",&x);
		t[mem[i]].sum=(x?true:false);
	}
	func();
	int T;
	memset(res,-1,sizeof(res));
	scanf("%d",&T);
	while(T--)
	{
		int x;
		scanf("%d",&x);
		if(res[x]!=-1)
		{
			printf("%d\n",res[x]);
			continue;
		}
		x=mem[x];
		update(x);
		int ans=t[root].sum?1:0;
		printf("%d\n",ans);
		res[x]=ans;
		update(x);
	}
	return 0;
}
