#include <iostream>
#include <cstdio>
#include <cstring>
#include <climits>
#define N 1010

using namespace std;

int n,m,ans=INT_MIN;
int p[N][N];
bool vis[N][N];

const int a[3]={0,1,-1};
const int b[3]={1,0,0};

void dfs(register int x,register int y,register int sum){
	if(x==n and y==m){
		ans=max(ans,sum);
		return;
	}
	vis[x][y]=true;
	for(int i=0;i<3;i++){
		int nx=x+a[i],ny=y+b[i];
		if(nx>=1 and nx<=n and ny>=1 and ny<=m and !vis[nx][ny]){
			dfs(nx,ny,sum+p[nx][ny]);
		}
	}
	vis[x][y]=false;
	return;
}

int main()
{
	freopen("number.in","r",stdin);
	freopen("number.out","w",stdout);
	scanf("%d%d",&n,&m);
	for(int i=1;i<=n;i++){
		for(int j=1;j<=m;j++){
			scanf("%d",&p[i][j]);
		}
	}
	dfs(1,1,p[1][1]);
	printf("%d\n",ans);
	return 0;
}