#include<bits/stdc++.h>
using namespace std;
int n, m;
int dx[3] = {1, -1, 0};
int dy[3] = {0, 0, 1};
int a[1005][1005], cut[1005][1005];


void bfs()
{
	priority_queue<pair<long long, pair<int, int> > > q;
	q.push(make_pair(1ll * a[1][1], make_pair(1, 1))); cut[1][1] = 1;
	while(!q.empty())
	{
		int	x = q.top().second.first, y = q.top().second.second;
		long long s = q.top().first; q.pop();
		cut[x][y] = 1;
		if(x == n && y == m)
		{
			printf("%lld", s);
			return;
		}
		for(int i = 0; i < 3; i++)
		{
			int tx = x + dx[i], ty = y + dy[i];
			long long ts = s + a[tx][ty];
			if(tx < 1 || ty < 1 || tx > n || ty > m || cut[tx][ty]) continue;
			q.push(make_pair(1ll * ts, make_pair(tx, ty)));
		}
	}
}


int main()
{
	freopen("number.in", "r", stdin);
	freopen("number.out", "w", stdout);
	scanf("%d%d", &n, &m);
	for(int i = 1; i <= n; i++)
		for(int j = 1; j <= m; j++)
			scanf("%d", &a[i][j]);
	bfs();
	return 0;
}
