#include <cstdio>
#include <cstring>
using namespace std;
const int N = 1000005;
char st[N];
int len, line[N], real[N], n, m, R[N], q,
	S[N], L[N], fa[N], top, val[N], x;
bool ans[N];
void getAns(int u){
//	printf("-> %d\n", u);
	if(L[u] == 0) {
		ans[u] = val[u];
		return;
	}
	getAns(L[u]);
	if(R[u] != 0) getAns(R[u]);
	if(val[u] == 2) ans[u] = ans[L[u]] & ans[R[u]];
	else if(val[u] == 3) ans[u] = ans[L[u]] | ans[R[u]];
	else ans[u] = ! ans[L[u]];
}
int Query(int u){
	if(L[u] == 0){
		ans[u] = 1 ^ ans[u];
		int an = Query(fa[u]);
		ans[u] = 1 ^ ans[u];
		return an;
	}
	int t = ans[u], an = 0;
	if(val[u] == 2) ans[u] = ans[L[u]] & ans[R[u]];
	else if(val[u] == 3) ans[u] = ans[L[u]] | ans[R[u]];
	else ans[u] = ! ans[L[u]];
	if(fa[u] == 0) an = ans[u];
	else an = Query(fa[u]);
	ans[u] = t;
	return an;
}
int main(){
	freopen("expr.in", "r", stdin);
	freopen("expr.out", "w", stdout);
	
	while(1){
		scanf("%s", st);
		len = strlen(st);
		if(st[0] >= '0' && st[0] <= '9'){
			for(int i = 0; i < len; i++)
				n = n*10 + (st[i] - '0');
			break;
		}
		if(st[0] == 'x'){
			int now = 0;
			for(int i = 1; i < len; i++)
				now = now*10 + (st[i] - '0');
			line[++m] = now;
			real[now] = m;
		}
		else if(st[0] == '&') line[++m] = -1;
		else if(st[0] == '|') line[++m] = -2;
		else if(st[0] == '!') line[++m] = -3;	
	}
/*
	printf("%d\n", n);
	for(int i = 1; i <= m; i++)
		printf("%d ", line[i]);
	printf("\n");
*/
	for(int i = 1; i <= m; i++){
		if(line[i] > 0) S[++top] = i;
		else if(line[i] == -1){
			int l = S[top--], r = S[top--];
			S[++top] = i;
			fa[l] = i; fa[r] = i;
			L[i] = l; R[i] = r;
			val[i] = 2;
		}else if(line[i] == -2){
			int l = S[top--], r = S[top--];
			S[++top] = i;
			fa[l] = i; fa[r] = i;
			L[i] = l; R[i] = r;
			val[i] = 3;
		}else{
			L[i] = S[top--], fa[L[i]] = i;
			S[++top] = i;
			val[i] = 4;
		}
	}
	
	for(int i = 1; i <= n; i++){
		scanf("%d", &x);
		val[real[i]] = x;
	}
/*
	for(int i = 1; i <= m; i++)
		printf("(%d: val%d, L%d, R%d, fa%d)\n", i, val[i], L[i], R[i], fa[i]);
*/	
	int root = 1;
	for(int i = 1; i <= m; i++)
		if(fa[i] == 0) root = i;
//	printf("%d", root);
//	return 0;
	getAns(root);
	scanf("%d", &q);
	for(int i = 1; i <= q; i++){
		scanf("%d", &x);
		printf("%d\n", Query(real[x]));
	}
	return 0;
} 
