#include<algorithm>
#include<iostream>
#include<cstring>
#include<cstdio>
#include<stack>
#include<cmath>

using namespace std;

const int N = 1100000;
struct TREE
{
	int ls, rs, op;
	bool x, change, ex;
}f[N];
int num[N], len, first[N], second[N];
stack<int>S;
int Out(bool x)
{
	if(x == false) return 0;
	return 1;
}
int another_son(int son1, int fa)
{
	if(f[fa].ls == son1) return f[fa].rs;
	return f[fa].ls;
}
int get_num(string s)
{
	int t = 0;
	for(int i = 0; i < s.size(); i ++)
	{
		if(s[i] >= '0' && s[i] <= '9') t = t * 10 + s[i] - 48;
	}
	return t;
}
void dfs(int now, int fa)
{
	if(now == -1) return;
	if(f[fa].change == false)
	{
		f[now].change = false;
	}
	else
	{
		bool t1 = f[now].x ^ 1, t2 = f[another_son(now, fa)].x, t;
		
		if(f[fa].op == -2)
		{
			t = t1 & t2;
		}
		else if(f[fa].op == -3)
		{
			t = t1 | t2;
		}
		t = t ^ f[fa].ex;
		if(t == f[fa].x)
		{
			f[now].change = false;
		}
		else
		{
			f[now].change = true;
		}
	}
	
	dfs(f[now].ls, now);
	dfs(f[now].rs, now);
	
}

int main()
{
	freopen("expr.in", "r", stdin);
	freopen("expr.out", "w", stdout);
	
	string s;
	int n, x, q;
	bool ans;
	cin >> s;
	while(!(s[0] >= '0' && s[0] <= '9'))
	{
		if(s[0] == 'x')
		{
			int t = get_num(s);
			first[++len] = t;
		}
		else if(s == "!") first[++len] = -1;
		else if(s == "&") first[++len] = -2;
		else if(s == "|") first[++len] = -3;
		cin >> s;
	}
	n = get_num(s);
	for(int i = 1; i <= n; i ++)
	{
		scanf("%d", &second[i]);
	}
	
	int Len = len;
	len = 0;
	for(int i = 1; i <= Len; i ++)
	{
		if(first[i] > 0)
		{
			f[++len].x = second[first[i]] & 1;
			f[len].ls = -1;
			f[len].rs = -1;
			f[len].ex = false;
			f[len].change = false;
			num[first[i]] = len;
			S.push(len);
		}
		else
		{
			if(first[i] == -1)
			{
				f[len].ex = true;
				f[len].x ^= true;
			}
			else
			{
				len ++;
				f[len].ls = S.top();
				S.pop();
				f[len].rs = S.top();
				S.pop();
				S.push(len);
				f[len].op = first[i];
				if(first[i] == -2)
				{
					f[len].x = f[f[len].ls].x & f[f[len].rs].x;
				}
				else if(first[i] == -3)
				{
					f[len].x = f[f[len].ls].x | f[f[len].rs].x;
				}
			}
		}
	}
	
	f[len].change = true;
	ans = f[len].x;
	dfs(f[len].ls, len);
	dfs(f[len].rs, len);
	
	scanf("%d", &q);
	for(int i = 1; i <= q; i ++)
	{
		scanf("%d", &x);
		if(f[num[x]].change == true)
		{
			printf("%d\n", Out(ans ^ 1));
		}
		else
		{
			printf("%d\n", Out(ans));
		}
	}
	return 0;
}
