#include <cstdio>
#include <stack>
#include <iostream>
using namespace std;

inline int read() {
	int flag = 1, x = 0;
	char ch = getchar();
	while(ch < '0' || ch > '9')
		{ if(ch == '-') flag = -1; ch = getchar(); }
	while(ch >= '0' && ch <= '9')
		x = (x << 1) + (x << 3) + (ch ^ 48), ch = getchar();
	return x * flag;
}

const int N = 1e5 + 7;

int nn, q, a[N], n;
string s;

stack < int > st;

inline void doit()
{
    for(int i=0; i<n; i++)
    {
        if(s[i] == 'x') {
            int x = 0, cnt = 0;
            while(s[i+cnt+1] >= '0' && s[i+cnt+1] <= '9') {
            	++cnt;
                x = (x << 1) + (x << 3) + (s[i+cnt] ^ 48);
            }
//            printf("%d\n", x);
            st.push(a[x]);
        }
        if(s[i] == '!') {
        	int x = st.top(); x = !x; st.pop(); st.push(x);
		}
        if(s[i] == '&') {
            int now1 = st.top(); st.pop();
            int now2 = st.top(); st.pop();
            st.push(now1 & now2);
        }
        if(s[i] == '|') {
            int now1 = st.top(); st.pop();
            int now2 = st.top(); st.pop();
            st.push(now1 | now2);
        }
    }
    printf("%d\n", st.top());
    while(!st.empty()) st.pop();
}

int main()
{
    freopen("expr.in", "r", stdin);
    freopen("expr.out", "w", stdout);

    getline(cin, s);
    n = s.length();
    nn = read();
    for(int i=1; i<=nn; i++)
        a[i] = read();
    q = read();
    while(q--) {
        int x; x = read(); a[x] = !a[x];
        doit();
        a[x] = !a[x];
    }
    return 0;
}
