#include <cstdio>
#include <cstring>
#define int long long

inline int read() {
	int flag = 1, x = 0;
	char ch = getchar();
	while(ch < '0' || ch > '9')
		{ if(ch == '-') flag = -1; ch = getchar(); }
	while(ch >= '0' && ch <= '9')
		x = (x << 1) + (x << 3) + (ch ^ 48), ch = getchar();
	return x * flag;
}

const int N = 1e3 + 7;

int n, m, a[N][N];
int ans = -0x3f3f3f3f3f3f3f3fLL;
bool vis[N][N];

int dx[4] = {0, 0, 1, -1};
int dy[4] = {1, -1, 0, 0};

inline int max(int x, int y) { return x > y ? x : y; }

inline int init(int x, int y) {
	if(x < 1 || y < 1) return 0;
	if(x > n || y > m) return 0;
	return 1;
}

inline void dfs(int x, int y, int sum)
{
//	printf("%lld %lld\n", x, y);

	if(x == n && y == m) {
		ans = max(ans, sum);
		return ;
	}

	for(int i=0; i<4; i++) {
		int tx = x + dx[i], ty = y + dy[i];
		if(!init(tx, ty)) continue;
		if(vis[tx][ty]) continue;
		vis[tx][ty] = 1;
		dfs(tx, ty, sum + a[tx][ty]);
		vis[tx][ty] = 0;
 	}
}

signed main()
{
	freopen("number.in", "r", stdin);
	freopen("number.out", "w", stdout);

	n = read(); m = read();
	for(int i=1; i<=n; i++)
	for(int j=1; j<=m; j++)
		a[i][j] = read();
	vis[1][1] = 1;
	dfs(1, 1, a[1][1]);
	printf("%lld", ans);
	return 0;
}
