#include <cstdio>
#include <queue>
#include <cstring>

inline int read() {
	int flag = 1, x = 0;
	char ch = getchar();
	while(ch < '0' || ch > '9')
		{ if(ch == '-') flag = -1; ch = getchar(); }
	while(ch >= '0' && ch <= '9')
		x = (x << 1) + (x << 3) + (ch ^ 48), ch = getchar();
	return x * flag;
}

const int NN = 300 * 300 + 7;
const int MM = (NN << 1);

struct edge
{
	int tot, Head[NN];
	int Next[MM], to[MM], val[MM];

	void add(int x, int y, int z) {
		tot++; 
		Next[tot] = Head[x];
		Head[x] = tot;
		to[tot] = y;
		val[tot] = z;
	}
} e;

const int N = 1e3 + 7;

int n, m, a[N][N];
int in[N], dis[N];

std :: queue < int > q;

inline int calc_point(int x, int y) {
	return (x - 1) * n + y;
}

bool vis[NN];

inline void SPFA() {
	memset(dis, -0x3f, sizeof(dis));
	q.push(1); vis[1] = 1; dis[1] = a[1][1];
	while(!q.empty())
	{
		int x = q.front(); q.pop(); vis[x] = 0;
		in[x]++; if(in[x] >= n * n) break;
		for(int i=e.Head[x]; i; i=e.Next[i]) {
			int v = e.to[i], h = e.val[i];
			if(dis[x] + h > dis[v]) {
				dis[v] = dis[x] + h;
				if(!vis[v]) q.push(v);
			}
		}
	}
	printf("%d", dis[calc_point(n, m)]);
}

int main()
{
    n = read(); m = read();
    for(int i=1; i<=n; i++)
    for(int j=1; j<=m; j++)
		a[i][j] = read();
	for(int i=1; i<=n; i++)
	for(int j=1; j<=m; j++) {
		e.add(calc_point(i, j), calc_point(i+1, j), a[i][j]);
		e.add(calc_point(i, j), calc_point(i, j+1), a[i][j]);
	}
	for(int i=1; i<=n; i++) {
		for(int j=1; j<=m; j++) {
			int x = calc_point(i, j);
			printf("point = %d\n", x);
			for(int t = e.Head[x]; i; i=e.Next[i]) {
				printf("v = %d cost = %d\n", e.to[i], e.val[i]);
			}
			puts("");
		}
	}
	SPFA();
}
