#include <iostream>
#include <cstdio>
using namespace std ;
int dx[3][2] = {1 , 0 , -1 , 0 , 0 , 1} ;
int visited[1005][1005] ;
int map[1005][1005] ;
int n , m ;
int ans = -999999999 ; 
void dfs(int x , int y , int sum) 
{
	if((x > n || x < 1 ) || (y > m || y < 1))
	{
		return ;
	}
	
	if(x == n && y == m)
	{
		ans = max(ans , sum) ;
		return ;
	}
	for (int i = 0 ; i <= 2 ; i++)
	{
		int xx = x + dx[i][0] ;
		int yy = y + dx[i][1] ;
		if(visited[xx][yy] == 0)
		{
			visited[xx][yy] = 1 ;
			dfs(xx , yy , sum + map[xx][yy]) ;
			visited[xx][yy] = 0 ;
		}
	}
}
int main()
{
	freopen("number.in", "r" , stdin) ;
	freopen("number.out" , "w" , stdout) ;
	cin >> n >> m;
	for (int i = 1 ; i <= n ; i ++ )
	{
		for (int j = 1 ; j <= m ; j ++)
		{
			cin >> map[i][j] ;
		}
	}
	dfs(1 , 1 , map[1][1]) ;
	cout << ans ;
	return 0 ;
}
