#include <bits/stdc++.h>
using namespace std;

const int MAX_N = 1e6;

string s, str;
vector<int> a, graph[MAX_N];
int cnt, pos, q;
bool val[MAX_N], v[MAX_N], ans[MAX_N];

void build(int x){
	pos--;
	if (x == 0 || pos == -1 || a[x] > 0){
		return;
	}
	for (int i = 1; i <= 2; i++){
		if (pos >= 0){
			graph[x].push_back(pos);
			build(pos);
		}else{
			break;
		}
	}
	return;
}

void dfs(int x){
	if (a[x] > 0){
		v[x] = val[x];
		return;
	}else{
		bool tmp;
		if (a[x] == - '&'){
			for (int i = 0; i < 1; i++){
				dfs(graph[x][i]);
				if (i == 0){
					tmp = v[graph[x][i]];
				}else{
					tmp = tmp && v[graph[x][i]];
				}
			}
			v[x] = tmp;
		}else if (a[x] == - '|'){
			for (int i = 0; i < 1; i++){
				dfs(graph[x][i]);
				if (i == 0){
					tmp = v[graph[x][i]];
				}else{
					tmp = tmp || v[graph[x][i]];
				}
			}
			v[x] = tmp;
		}else{
			dfs(graph[x][0]);
			v[x] = !v[graph[x][0]];
		}
	}
}

void get_ans(int x, bool could){
	cout << x << " " << could << endl;
	if (a[x] > 0){
		ans[a[x]] = could;
	}else if (a[x] == - '&'){
		if (could){
			for (int i = 0; i < graph[x].size(); i++){
				get_ans(graph[x][i], true);
			}
		}else{
			if (v[x]){
				for (int i = 0; i < 1; i++){
					get_ans(graph[x][i], false);
				}
			}else{
				if (v[graph[x][0]] == v[graph[x][1]]){
					get_ans(graph[x][0], true);
					get_ans(graph[x][1], true);
				}else{
					get_ans(graph[x][0], v[graph[x][0]]);
					get_ans(graph[x][1], v[graph[x][1]]);
				}
			}
		}
	}else if (a[x] == - '|'){
		if (could){
			for (int i = 0; i < 1; i++){
				get_ans(graph[x][i], true);
			}
		}else{
			if (v[x]){
				for (int i = 0; i < 1; i++){
					get_ans(graph[x][i], false);
				}
			}else{
				if (v[graph[x][0]] == v[graph[x][1]]){
					get_ans(graph[x][0], true);
					get_ans(graph[x][1], true);
					
				}else{
					get_ans(graph[x][0], !v[graph[x][0]]);
					get_ans(graph[x][1], !v[graph[x][1]]);
				}
			}
		}
	}else{
		get_ans(graph[x][0], could);
	}
	return;
}

int main(){
	getline(cin, str);
	str += ' ';
	for (int i = 0; i < str.size(); i++){
		if (str[i] == ' '){
			int len = s.size();
			if (len == 1){
				a.push_back(-(int) s[0]);
			}else{
				int tmp = 0;
				for (int i = 1; i < len; i++){
					tmp += pow(10, len - i - 1) * (s[i] - '0');
				}
				//cout << tmp;
				a.push_back(tmp);
			}
			s = "";
		}else{
			s += str[i];
		}
	}
	scanf("%d", &cnt);
	for (int i = 0; i < cnt; i++){
		scanf("%d", &val[i]);
	}
	pos = a.size() - 1;
	build(a.size() - 1);
	dfs(a.size() - 1);
	/*for (int i = 0; i < a.size(); i++){
		cout << v[i] << " ";
		/*cout << i << ": ";
		for (int j = 0; j < graph[i].size(); j++){
			cout << graph[i][j] << " ";
		}
		cout << endl;
	}*/
	get_ans(a.size() - 1, false);
	scanf("%d", &q);
	while (q--){
		int t;
		scanf("%d", &t);
		if (ans[t]){
			printf("%d\n", v[a.size() - 1]);
		}else{
			printf("%d\n", !v[a.size() - 1]);
		}
	}
	//cout << cnt << a.size();
}
