#include <iostream>
#include <cstdio>
#include <stack>
using namespace std;

struct node {
	node(int a) : s(a), parent(0), l(0), r(0) {
	}
	node* parent;
	node* l, *r;
	int s;// 0룬-1-2 
	bool rv;
//	int n;// ڵΪ0 
};
node* x[100005] = { 0 };
node* root;

int parseint(char* in) {
	int n = 0, i = 0;
	while (in[i]) {
		n *= 10;
		n += in[i++] - '0';
	}
	return n;
}

//void foreach(node* root, int n = 0) {
//	root->n = n;
//	if (root->l) foreach(root->l, n + 1);
//	if (root->r) foreach(root->r, n + 1);
//}

void cal(node* root) {
	switch (root->s) {
		case 0: {
			cal(root->l);
			cal(root->r);
			root->rv = root->l->rv && root->r->rv;
			break;
		}
		case -1: {
			cal(root->l);
			cal(root->r);
			root->rv = root->l->rv || root->r->rv;
			break;
		}
		case -2: {
			cal(root->l);
			root->rv = !root->l->rv;
			break;
		}
		default: break;
	}
}

bool getValue(int s, bool l, bool r) {
	switch (s) {
		case 0: return l && r;
		case -1: return l || r;
		case -2: return !l;
	}
	return 0;
}

bool change(node* n) {
	node* p = n->parent;
	if (!p) return !n->rv;
	bool prv = p->rv;
	node* brother;
	if (p->l == n) brother = p->r;
	else brother = p->l;
	bool changed = getValue(p->s, !n->rv, brother ? brother->rv : 0);
	if (changed == prv) return root->rv;
	return change(p);
}

int main() {
	FILE* in, *out;
	in = fopen("expr.in", "r");
	out = fopen("expr.out", "w");
	char expnode[16] = "";
	stack<node*> stk;
	while (true) {
		fscanf(in, "%s", expnode);
		if (expnode[0] >= '0' && expnode[0] <= '9') break;
		switch (expnode[0]) {
			case 'x': {
				int id = parseint(expnode + 1);
				stk.push(x[id] = new node(id));
				break;
			}
			case '&': {
				node* n = new node(0);
				node* r = stk.top();
				stk.pop();
				node* l = stk.top();
				stk.pop();
				r->parent = l->parent = n;
				n->l = l, n->r = r;
				stk.push(n);
				break;
			}
			case '|': {
				node* n = new node(-1);
				node* r = stk.top();
				stk.pop();
				node* l = stk.top();
				stk.pop();
				r->parent = l->parent = n;
				n->l = l, n->r = r;
				stk.push(n);
				break;
			}
			case '!': {
				node* n = new node(-2);
				node* c = stk.top();
				stk.pop();
				c->parent = n;
				n->l = c;
				stk.push(n);
				break;
			}
		}
	}
	int n = parseint(expnode);
	root = stk.top();
//	foreach(root);
//	printf("%d", n);
	int tmp;
	for (int i = 1; i <= n; i++) {
		fscanf(in, "%d", &tmp);
		x[i]->rv = tmp;
	}
	cal(root);
	int q;
	fscanf(in, "%d", &q);
	for (int i = 0; i < q; i++) {
		int id;
		fscanf(in, "%d", &id);
		fprintf(out, "%d\n", change(x[id]));
	}
	fclose(in);
	fclose(out);
	return 0;
}
