#include <iostream>
#include <cstdio>
#define MIN -0x7ffffff
using namespace std;
const int gx[] = {0,1,-1};
const int gy[] = {1,0,0};
int n,m;
int map[1001][1001];
long long ans[3][1001][1001];
bool visit[1001][1001];
long long dfs(int x,int y,int which)
{
	if(ans[which][x][y] != MIN)return ans[which][x][y];
	if(x == n && y == m)return map[x][y];
	visit[x][y] = true;
	long long answer = MIN;
	for(int i = 0; i < 3; i++)
	{
		int newx = x + gx[i];
		int newy = y + gy[i];
		if(newx < 1 || newx > n || newy < 1 || newy > m || visit[newx][newy])
		{
			continue;
		}
		answer = max(answer,dfs(newx,newy,i) + map[x][y]);
	}
	visit[x][y] = false;
	ans[which][x][y] = answer;
	return ans[which][x][y];
}
int main()
{
	freopen("number.in","r",stdin);
	freopen("number.out","w",stdout);
	ios::sync_with_stdio(false);
	cin >> n >> m;
	for(int i = 1; i <= n; i++)
	    for(int j = 1; j <= m; j++)
	        cin >> map[i][j],ans[0][i][j] = MIN,ans[1][i][j] = MIN,ans[2][i][j] = MIN;
	cout << max(dfs(1,1,0),max(dfs(1,1,1),dfs(1,1,2)));
	return 0;
}
