#include <iostream>
#include <cstdio>
#include <cmath>
#include <iomanip>
#include <cstring>
#include <algorithm>
#include <vector>
using namespace std;
int n, w;
vector<int> a(2);
int find(int m, int target)
{
	if(target >= a[1])
		return 1;
	if(target <= a[m - 1])
		return m;
	int l = 1, r = m;
	while(l <= r)
	{
		int mid = l + (r - l) / 2;
		if(target >= a[mid + 1] && target <= a[mid])
			return mid + 1;
		if(target < a[mid])
			l = mid + 1;
		else
			r = mid - 1;
	}
	return 0;
}
int main()
{
	freopen("live.in", "r", stdin);
	freopen("live.out", "w", stdout);
	scanf("%d%d", &n, &w);
	for(int i = 1; i <= n; i++)
	{
		int x;
		cin >> x;
		if(i == 1)
		{
			a[1] = x;
			cout << x;
			continue;
		}
		a.insert(a.begin() + find(i, x), x);
		int next = max(1, i * w / 100);
		printf(" %d", a[next]);
	}
	return 0;
}
