#include <iostream>
#include <cstdio>
#include <cmath>
#include <cstring>
#include <iomanip>
#include <algorithm>
using namespace std;
int n, m, a[1010][1010], ans = -2147483647;
bool b[1010][1010];
const int dx[4] = {0, 0, 1, -1};
const int dy[4] = {1, -1, 0, 0};
void dfs(int x, int y, int val)
{
	if(x == n && y == m)
	{
		ans = max(ans, val + a[x][y]);
		return;
	}
	for(int i = 0; i < 4; i++)
	{
		int nx = x + dx[i];
		int ny = y + dy[i];
		if(1 <= nx && nx <= n && 1 <= ny && ny <= m && b[nx][ny] == 0)
		{
			b[nx][ny] = 1;
			dfs(nx, ny, val + a[x][y]);
			b[nx][ny] = 0;
		}
	}
}
int main()
{
	freopen("number.in", "r", stdin);
	freopen("number.out", "w", stdout);
	cin >> n >> m;
	for(int i = 1; i <= n; i++)
		for(int j = 1; j <= m; j++)
			cin >> a[i][j];
	b[1][1] = 1;
	dfs(1, 1, 0);
	cout << ans << endl;
	return 0;
}
