#include<bits/stdc++.h>
#define Maxn 1000000
using namespace std;
struct node{
	int initia_v;
	char lambda;
	node *lch,*rch,*fa;
	node():initia_v(-1),lch(NULL),rch(NULL),fa(NULL){}
};
node *x_mem[Maxn + 1];
int get_val(node *p){
	if(p->initia_v != -1)
		return p->initia_v;
	if(p->lambda == '!'){
		p->initia_v = get_val(p->lch) ^ 1;
		return p->initia_v;
	}
	if(p->lambda == '&'){
		p->initia_v = get_val(p->lch) & get_val(p->rch);
		return p->initia_v;
	}
	if(p->lambda == '|'){
		p->initia_v = get_val(p->lch) | get_val(p->rch);
		return p->initia_v;
	}
}
bool inf(node *p){
	if(p->fa == NULL)
		return true;
	if(p->fa->lambda == '!')
		return inf(p->fa);
	if(p->fa->lambda == '&'){
		if(p->initia_v == 1 && p->fa->initia_v == 1)
			return inf(p->fa);
		if(p->initia_v == 0 && (p->fa->lch->initia_v == 1 || p->fa->rch->initia_v == 1))
			return inf(p->fa);
		return false;
	}
	if(p->fa->lambda == '|'){
		if(p->initia_v == 0 && p->fa->initia_v == 0)
			return inf(p->fa);
		if(p->initia_v == 1 && (p->fa->lch->initia_v == 0 || p->fa->rch->initia_v == 0))
			return inf(p->fa);
		return false;
	}
}
int main(){
	freopen("expr.in","r",stdin);
	freopen("expr.out","w",stdout);
	string str;
	stack<node*> st;
	node *root;
	getline(cin,str);
	int len = str.length();
	for(int i = 0;i < len;i++){
		if(str[i] == 'x'){
			int num = 0,j = i + 1;
			while(j < len && str[j] >= '0' && str[j] <= '9'){
				num *= 10;
				num += str[j] - '0';
				j++;
			}
			x_mem[num] = new node;
			x_mem[num]->lambda = str[i];
			st.push(x_mem[num]);
		}
		if(str[i] == '!'){
			root = new node;
			root->lambda = str[i];
			root->lch = st.top();
			root->lch->fa = root;
			st.pop();
			st.push(root);
		}
		if(str[i] == '&' || str[i] == '|'){
			root = new node;
			root->lambda = str[i];
			root->lch = st.top();
			root->lch->fa = root;
			st.pop();
			root->rch = st.top();
			root->rch->fa = root;
			st.pop();
			st.push(root);
		}
	}
	root = st.top();
	st.pop();
	int n;
	scanf("%d",&n);
	for(int i = 1;i <= n;i++)
		scanf("%d",&x_mem[i]->initia_v);
	int initia_ans = get_val(root);
	int q;
	scanf("%d",&q);
	for(int i = 0;i < q;i++){
		int req;
		scanf("%d",&req);
		bool change = inf(x_mem[req]);
		printf("%d\n",change ^ initia_ans);
	}
	return 0;
}

