#include <cstdio>
#include <cstring>

using namespace std;

int n, m;
long long a[1010][1010], f[1010], g[1010], h[1010];

long long max(long long x, long long y) { return x > y ? x : y; }

char buf[1 << 20];
int p = 1 << 20;

inline char gc() {
	if (p == 1 << 20) {
		memset(buf, 0, sizeof(buf));
		fread(buf, sizeof(char), 1 << 20, stdin);
		p = 0;
	}
	return buf[p++];
}
void read(long long& x) {
	static char ch = gc();
	static bool flag;
	while (ch < '0' && ch != '-') ch = gc();
	if (ch == '-') {
		flag = 1;
		ch = gc();
	} else flag = 0;
	while (ch >= '0') {
		x = x * 10 + ch - '0';
		ch = gc();
	}
	if (flag) x = -x;
}

int main() {
	freopen("number.in", "r", stdin);
	freopen("number.out", "w", stdout);
	scanf("%d%d", &n, &m);
	for (int i = 1; i <= n; ++i)
		for (int j = 1; j <= m; ++j) {
			read(a[i][j]);
			a[i][j] += a[i - 1][j];
		}
	for (int i = 1; i <= n; ++i) f[i] = a[i][1];
	g[0] = h[n + 1] = -1e9;
	for (int i = 2; i <= m; ++i) {
		 for (int j = 1; j <= n; ++j) g[j] = max(g[j - 1], f[j] - a[j - 1][i]);
		 for (int j = n; j >= 1; --j) h[j] = max(h[j + 1], f[j] + a[j][i]);
		 for (int j = 1; j <= n; ++j) f[j] = max(g[j] + a[j][i], h[j] - a[j - 1][i]);
	}
	printf("%lld\n", f[n]);
	fclose(stdin);
	fclose(stdout);
	return 0;
}
