#include <fstream>
//#define IO_IN_CONSOLE
#ifdef IO_IN_CONSOLE
#define IN_FILE "CON"
#define OUT_FILE "CON"
#else
#define IN_FILE "number.in"
#define OUT_FILE "number.out"
#endif
using namespace std;
int nWidth,nHeight;
int nDataRect[1000][1000];
bool bVisited[1000][1000]={false};
int nMaximum=0;
bool bCheck(int nPosX,int nPosY){
	if(nPosX<0||nPosY<0){
		return false;
	}
	if(nPosX>=nHeight||nPosY>=nWidth){
		return false;
	}
	return !bVisited[nPosX][nPosY];
}
void dfs(int nPosX,int nPosY,int nSum){
	bVisited[nPosX][nPosY]=true;
	nSum+=nDataRect[nPosX][nPosY];
	if(nPosX==nHeight-1&&nPosY==nWidth-1){
		if(nSum>nMaximum){
			nMaximum=nSum;
		}
		bVisited[nPosX][nPosY]=false;
		return;
	}
	if(bCheck(nPosX-1,nPosY)){
		dfs(nPosX-1,nPosY,nSum);
	}
	if(bCheck(nPosX+1,nPosY)){
		dfs(nPosX+1,nPosY,nSum);
	}
	if(bCheck(nPosX,nPosY-1)){
		dfs(nPosX,nPosY-1,nSum);
	}
	if(bCheck(nPosX,nPosY+1)){
		dfs(nPosX,nPosY+1,nSum);
	}
	bVisited[nPosX][nPosY]=false;
}
int main(void) {
	ifstream input(IN_FILE);
	ofstream output(OUT_FILE);
	input>>nHeight>>nWidth;
	for(int i=0; i<nHeight; i++) {
		for(int j=0; j<nWidth; j++) {
			input>>nDataRect[i][j];
			if(nHeight&1||nWidth&1) {
				nMaximum+=nDataRect[i][j];
			}else{
				if(i<nHeight-1){
					nMaximum+=nDataRect[i][j];
				}
			}
		}
	}
	dfs(0,0,0);
	output<<nMaximum;
	return 0;
}
