#include <iostream>
#include <cstdio>

using namespace std;

int N, M;
int Graph[1005][1005];
long long Res = -1000000000000;
int Dx[5] = {0, -1, 1};
int Dy[5] = {1, 0, 0};
bool Vis[1005][1005];

long long max (long long x, long long y) {
	if (x > y) {
		return x;
	}
	return y;
}

void Search (int X, int Y, long long Cnt) {
	if (X == N && Y == M) {
		Res = max (Res, Cnt);
		return;
	}
	for (int i = 0; i < 3; i ++) {
		int XX = X + Dx[i];
		int YY = Y + Dy[i];
		if (XX < 1 || YY < 1 || XX > N || YY > M || Vis[XX][YY]) {
			continue;
		}
		Vis[XX][YY] = 1;
		Search (XX, YY, Cnt + Graph[XX][YY]);
		Vis[XX][YY] = 0;
	}
}

int main () {
	
	freopen("number.in", "r", stdin);
	freopen("number.out", "w", stdout);

	scanf ("%d %d", &N, &M);
	for (int i = 1; i <= N; i ++) {
		for (int j = 1; j <= M; j ++) {
			scanf ("%d", &Graph[i][j]);
		}
	}
	
	Vis[1][1] = 1;
	Search (1, 1, Graph[1][1]);
	
	printf ("%lld\n", Res);
	
	
	fclose(stdin);
	fclose(stdout);
	
	return 0;
}
