#include <iostream>
#include <cstdio>
#include <algorithm>
const int inf = 0x3f3f3f3f;
using namespace std;
int vis[1010][1010];
int maze[1010][1010];
int dir[3][2] = {{0, 1}, {1, 0}, {0, -1}};
int maxn = -inf;
int n, m;
bool in(int x, int y) {
	if (x <= n && y <= m && x > 0 && y > 0)
		return true;
	else
		return false;
}
void dfs(int x, int y, int k) {
	if (x == n && y == m) {
		if (k > maxn)
			maxn = k;
		return ;
	}
	for (int i = 0; i < 3; i++) {
		int tx = x + dir[i][0];
		int ty = y + dir[i][1];
		if (in(tx, ty) && !vis[tx][ty]) {
			vis[tx][ty] = true;
			k += maze[tx][ty];
			dfs(tx, ty, k);
		}
		k -= maze[tx][ty];
		vis[tx][ty] = false;
	}
	return ;
}
int main()
{
	freopen("number.in", "r", stdin);
	freopen("number.out", "w", stdout);
	cin >> n >> m;
	for (int i = 1; i <= n; i++)
		for (int j = 1; j <= m; j++)
			cin >> maze[i][j];
	vis[1][1] = true;
	dfs(1, 1, maze[1][1]);
	cout << maxn << endl;
	return 0;
}
