#include <iostream>
#include <cstdio>
#include <stack>

using namespace std;

string s, t;
int arr[100005], c[100005], q, temp;

int does(int a, int b, int chr){
	if (chr == '&')
		return arr[a] & arr[b];
	else
		return arr[a] | arr[b];
	
}

int main(){
	
	freopen("expr.in", "r", stdin);
	freopen("expr.out", "w", stdout);
	
	getline(cin, s);
	int n; scanf("%d", &n);
	for (int i = 1; i <= n; i++){
		scanf("%d", &arr[i]);
		c[i] = arr[i];
	}
		
	scanf("%d", &q);
	
	stack<int> stk;
	stack<char> st;
	
	for (int i = 0; i < s.length(); i++){
		
		if (s[i] == 'x'){
			for (int j = i+1; '0' <= s[j] && s[j] <= '9'; j++)
				temp = temp*10+s[j]-'0';
			stk.push(temp);
		}
				
		if (s[i] == '&' || s[i] == '|' || s[i] == '!')
			st.push(s[i]);			
	}
	
	for (int i = 1; i <= q; i++){
		
		scanf("%d", &temp);
		arr[temp] = !arr[temp];
		
		while (!st.empty() || !stk.empty()){
			
			char chr = st.top();
			st.pop();
			if (chr == '!'){
				int a = stk.top();
				arr[a] = !arr[a];
			}
			else{
				int a = stk.top();
				stk.pop();
				int b = stk.top();
				stk.pop();			
				stk.push(does(a, b, chr));
			}
			
		}
		
		cout << stk.top() << endl;
		for (int i = 1; i <= n; i++)
			arr[i] = c[i];
	}
	
	fclose(stdin);
	fclose(stdout);
	
	return 0;
}
