#include <iostream>
#include <cstdio>
#include <queue>
#define INF 0x80000000
using namespace std;

int mp[1001][1001],n,m;
int ans=INF;

void dfs(int x,int y,int s)
{
	if(x==n&&y==m)
	{
		ans=max(ans,s);
		return;
	}
	if(x<1||y<1||x>n||y>m)
	{
		return;
	}
	int u,d,r;
	u=x>1?mp[x-1][y]:INF;
	d=x<n?mp[x+1][y]:INF;
	r=y<m?mp[x][y+1]:INF;
	mp[x][y]=INF;
	if(u==d&&u==r&&u==INF)
		return;
	if(u>d&&u>r)
	{
		dfs(x-1,y,s+u);
		return;
	}
	if(d>u&&d>r)
	{
		dfs(x+1,y,s+d);
		return;
	}
	if(r>d&&r>u)
	{
		dfs(x,y+1,s+r);
		return;
	}
	if(u==d)
	{
		dfs(x-1,y,s+u);
		dfs(x+1,y,s+d);
		return;
	}
	if(u==r)
	{
		dfs(x-1,y,s+u);
		dfs(x,y+1,s+r);
		return;
	}
	if(r==d)
	{
		dfs(x+1,y,s+d);
		dfs(x,y+1,s+r);
		return;
	}
	if(u==d&&u==r)
	{
		dfs(x-1,y,s+u);
		dfs(x+1,y,s+d);
		dfs(x,y+1,s+r);
		return;
	}
}

int main()
{
	freopen("number.in","r",stdin);
	freopen("number.out","w",stdout);
	
	scanf("%d%d",&n,&m);
	for(int i=1;i<=n;++i)
	{
		for(int j=1;j<=m;++j)
		{
			scanf("%d",&mp[i][j]);
		}
	}
	dfs(1,1,mp[1][1]);
	cout<<ans;
	fclose(stdin);
	fclose(stdout);
	return 0;
}

