#include <bits/stdc++.h>
#define int long long

using namespace std;

const int dir[4][2] = {{0, 1}, {0, -1}, {1, 0}, {-1, 0}};
const int N = 2e3;

int n, m, ans = INT_MIN;
int a[N][N], f[N][N];
bool vis[N][N];

inline bool check(int x, int y) {return 0 < x && x <= n && 0 < y && y <= m && !vis[x][y];}

inline void TLE(int x, int y, int sum) {
	//printf("x = %d, y = %d, sum = %d\n", x, y, sum);
	if(x == n && y == m) {
		ans = max(ans, sum + a[x][y]);
		return;
	}
	for(int i = 0; i < 4; ++i) {
		int nx = x + dir[i][0];
		int ny = y + dir[i][1];
		if(check(nx, ny)) {
			vis[nx][ny] = true;
			TLE(nx, ny, sum + a[x][y]);
			vis[nx][ny] = false;
		}
	}
}

signed main() {
	freopen("number.in", "r", stdin);
	freopen("number.out", "w", stdout);
	scanf("%lld %lld", &n, &m);
	for(int i = 1; i <= n; ++i)
		for(int j = 1; j <= m; ++j) {
			scanf("%lld", &a[i][j]);
		}
	
	vis[1][1] = true;
	TLE(1, 1, 0);
	printf("%lld\n", ans);
	return 0;
}


/*

f[i][j] -> From (1,1) to (i, j) Max Value
f[i][j] = max(f[i][j - 1] + a[i][j], f[i - 1][j] + a[i][j], 
				f[i][j + 1] + a[i][j], f[i + 1][j] + a[i][j])


3 4
1 -1 3 2
2 -1 4 -1
-2 2 -3 -1


//	for(int i = 1; i <= n; ++i)
//		for(int j = 1; j <= m; ++j) {
//			f[i][j] = maxn(f[i][j - 1], f[i - 1][j], f[i + 1][j], f[i][j + 1]) + a[i][j];
//		}
//	printf("%d\n", dfs(n, m));
//	printf("%d\n", f[n][m]);
//	printf("%d\n", dg(n, m));

//
//inline int dfs(int x, int y) {
//	if(f[x][y] != -1) return f[x][y];
//	if(x == 0 && y == 0) return a[x][y];
//	
//	int ans = 0;
//	for(int i = 0; i < 4; ++i) {
//		int nx = x + dir[i][0];
//		int ny = y + dir[i][1];
//		if(check(nx, ny))
//			ans = max(ans, dfs(nx, ny) + a[x][y]);
//	}
//	return f[x][y] = ans;
//}
//inline int maxn(int a, int b, int c, int d) {
//	return max(a, max(b, max(c, d)));
//}
//
//inline int dg(int x, int y) {
//	if(!check(x, y)) return 0;
//	if(f[x][y] != -1) return f[x][y];
//	if(x == 1 || y == 1) return a[x][y];
//	return maxn(dg(x, y - 1), dg(x, y + 1), dg(x - 1, y), dg(x + 1, y)) + a[x][y];
//}

*/
