#include <bits/stdc++.h>

using namespace std;

const int N = 1e3 + 100;
const int dir[4][2] = {{0, 1}, {0, -1}, {1, 0}, {-1, 0}};

int n, m, a[N][N], f[N][N];

inline bool check(int x, int y) {
	return 0 < x && x <= n && 0 < y && y <= m;
}

inline int dfs(int x, int y) {
//	printf("x = %d, y = %d\n", x, y);
	if(f[x][y] != -1) return f[x][y];
	if(x <= 1 && y <= 1) return a[x][y];
	
	int ans = 0;
	for(int i = 0; i < 4; ++i) {
		int nx = x + dir[i][0];
		int ny = y + dir[i][1];
		if(check(nx, ny))
			ans = max(ans, dfs(nx, ny) + a[x][y]);
	}
	return f[x][y] = ans;
}

signed main() {
	scanf("%d %d", &n, &m);
	for(int i = 1; i <= n; ++i)
		for(int j = 1; j <= m; ++j) {
			scanf("%d", &a[i][j]);
			f[i][j] = -1;
		}
	
	
	
	printf("%d\n", dfs(n, m));
	for(int i = 1; i <= n; ++i)
		for(int j = 1; j <= m; ++j) {
			printf("f[%d][%d] = %d\n", i, j, f[i][j]);
		}
	return 0;
}
