#include <stdio.h>
#define MIN (-2147483647L - 1)
typedef struct
{
	short i;
	short j;
}C;
int n,m;
int a[1024][1024];
int index[1024][1024];
int visit[1024][1024];
long long dis[1024][1024];//dis
C h[1000005];
int len;

int Check(C x)
{
	return (x.i>=1)&&(x.j>=1)&&(x.i<=n)&&(x.j<=m)&&(visit[x.i][x.j]==0);
}

C Out(void)
{
	C re=h[1];
	int parent=1,child=2;
	while(child<len)
	{
		if(dis[h[child].i][h[child].j]<dis[h[child+1].i][h[child+1].j]&&child+1<len)
			child++;
		if(dis[h[len].i][h[len].j]<dis[h[child].i][h[child].j])
		{
			h[parent]=h[child];
			index[h[parent].i][h[parent].j]=parent;
			parent=child;
			child<<=1;
		}
		else
			break;
	}
	h[parent]=h[len];
	index[h[parent].i][h[parent].j]=parent;
	len--;
	return re;
}
void Add(C x)
{
	len++;
	int parent=len>>1;
	int child=len;
	while(child>1)
	{
		if(dis[h[parent].i][h[parent].j]<dis[x.i][x.j])
		{
			h[child]=h[parent];
			index[h[child].i][h[child].j]=child;
			child=parent;
			parent>>=1;
		}
		else
			break;
	}
	h[child]=x;
	index[x.i][x.j]=child;
}
void Update(C x)
{
	len++;
	int parent=index[x.i][x.j]>>1;
	int child=index[x.i][x.j];
	while(child>1)
	{
		if(dis[h[parent].i][h[parent].j]<dis[x.i][x.j])
		{
			h[child]=h[parent];
			index[h[child].i][h[child].j]=child;
			child=parent;
			parent>>=1;
		}
		else
			break;
	}
	h[child]=x;
	index[x.i][x.j]=child;
}
/*
void Show()
{
	int i;
	printf("%d:\n",len);
	for(i=1;i<=len;i++)
	{
		printf("%d %d\n",h[i].i,h[i].j);
	}
	printf("\n");
	scanf("%*c");
}*/

int main()
{
	FILE* fin=fopen("number.in","r");
	FILE* fout=fopen("number.out","w");
	//FILE* fout=stdout;
	fscanf(fin,"%d%d",&n,&m);
	int i,j;
	for(i=1;i<=n;i++)
	{
		for(j=1;j<=m;j++)
		{
			fscanf(fin,"%d",&a[i][j]);
			dis[i][j]=MIN;
		}
	}
	dis[1][1]=a[1][1];
	C t={1,1},x;
	Add(t);
	while(len>0)
	{
		t=Out();
		visit[t.i][t.j]=1;
	//	Show();
		if(t.i==n&&t.j==m)
			break;
		x.i=t.i;
		x.j=t.j+1;
		if(Check(x))
		{
			if(dis[x.i][x.j]<dis[t.i][t.j]+a[x.i][x.j])
				dis[x.i][x.j]=dis[t.i][t.j]+a[x.i][x.j];
			if(index[x.i][x.j]==0)
				Add(x);
			else
				Update(x);
		}
		x.i=t.i;
		x.j=t.j-1;
		if(Check(x))
		{
			if(dis[x.i][x.j]<dis[t.i][t.j]+a[x.i][x.j])
				dis[x.i][x.j]=dis[t.i][t.j]+a[x.i][x.j];
			if(index[x.i][x.j]==0)
				Add(x);
			else
				Update(x);
		}
		x.i=t.i+1;
		x.j=t.j;
		if(Check(x))
		{
			if(dis[x.i][x.j]<dis[t.i][t.j]+a[x.i][x.j])
				dis[x.i][x.j]=dis[t.i][t.j]+a[x.i][x.j];
			if(index[x.i][x.j]==0)
				Add(x);
			else
				Update(x);
		}
		x.i=t.i-1;
		x.j=t.j;
		if(Check(x))
		{
			if(dis[x.i][x.j]<dis[t.i][t.j]+a[x.i][x.j])
				dis[x.i][x.j]=dis[t.i][t.j]+a[x.i][x.j];
			if(index[x.i][x.j]==0)
				Add(x);
			else
				Update(x);
		}
	}
	fprintf(fout,"%lld",dis[n][m]);
	fclose(fin);
	fclose(fout);
	return 0;
}
