#include <bits/stdc++.h>
#define reg register
#define ln putchar('\n')
#define lsp putchar(32)
using namespace std;
const int MaxN=100050;
template<class t> inline void read(t &s)
{
	s=0;
	reg char c=getchar();
	reg int f=1;
	while(!isdigit(c))
	{
		if(c=='-')
			f=-1;
		c=getchar();
	}
	while(isdigit(c))
		s=(s<<3)+(s<<1)+(c^48),c=getchar();
	s*=f;
	return ;
}
template<class t> inline void write(t x)
{
	static int buf[21],top=0;
	if(x<0)
	{
		putchar('-');
		x=-x;
	}
	if(!x)
	{
		putchar('0');
		return;
	}
	top=0;
	while(x)
		buf[top++]=(x%10),x/=10;
	while(top--)
		putchar(buf[top]^48);
	return ;
}
namespace Splay
{
	const int MaxN=100050;
	int ch[MaxN][2],f[MaxN],siz[MaxN],cnt[MaxN],val[MaxN],ndn,root;
	inline void clear(int x)
	{
		ch[x][0]=ch[x][1]=f[x]=siz[x]=cnt[x]=val[x]=0;
		return;
	}
	inline int get(int x)
	{
		return ch[f[x]][1]==x;
	}
	inline void pushup(int x)
	{
		if(x)
		{
			siz[x]=cnt[x];
			if(ch[x][0])
				siz[x]+=siz[ch[x][0]];
			if(ch[x][1])
				siz[x]+=siz[ch[x][1]];
		}
		return;
	}
	inline void connect(int u,int fa,int k)
	{
		if(u)
			f[u]=fa;
		if(fa)
			ch[fa][k]=u;
		return;
	}
	inline void rotate(int u)
	{
		reg int fa=f[u],ffa=f[fa],kfa=get(u),kffa=get(fa);
		connect(ch[u][kfa^1],fa,kfa);
		connect(fa,u,kfa^1);
		connect(u,ffa,kffa);
		pushup(fa),pushup(u);
		return;
	}
	inline void splay(int u)
	{
		for(reg int fa;fa=f[u],fa;rotate(u))
			if(f[fa])
				rotate(get(u)==get(fa)?fa:u);
		root=u;
		return;
	}
	inline void insert(int x)
	{
		if(!root)
		{
			root=++ndn;
			val[root]=x;
			cnt[root]=1;
			pushup(root);
			return;
		}
		reg int pre=0,pos=root;
		while(true)
		{
			if(val[pos]==x)
			{
				++cnt[pos];
				splay(pos);
				return;
			}
			pre=pos,pos=ch[pos][x>val[pos]];
			if(!pos)
			{
				pos=++ndn;
				connect(pos,pre,x>val[pre]);
				val[pos]=x;
				cnt[pos]=1;
				splay(pos);
				return;
			}
		}
		return;
	}
	inline int kth(int x)
	{
		reg int pos=root;
		while(true)
		{
			if(ch[pos][1]&&x<=siz[ch[pos][1]])
			{
				pos=ch[pos][1];
				continue;
			}
			if(ch[pos][1])
				x-=siz[ch[pos][1]];
			if(x<=cnt[pos])
				return val[pos];
			x-=cnt[pos];
			pos=ch[pos][0];
		}
		return -1;
	}
}
int a[MaxN];
#define lson (u<<1)
#define rson (u<<1|1)
inline void pushup(int u)
{
	a[u]=a[lson]+a[rson];
	return;
}
inline void modify(int u,int l,int r,int p,int k)
{
	if(l==r)
	{
		a[u]+=k;
		return;
	}
	reg int mid=(l+r)>>1;
	p<=mid?modify(lson,l,mid,p,k):modify(rson,mid+1,r,p,k);
	pushup(u);
	return;
}
inline int kth(int u,int l,int r,int k)
{
	if(l==r)
		return l;
	reg int mid=(l+r)>>1;
	return k<=a[rson]?kth(rson,mid+1,r,k):kth(lson,l,mid,k-a[rson]);
}
#undef lson
#undef rson
int n,W;
signed main(void)
{
	freopen("live.in","r",stdin);
	freopen("live.out","w",stdout);
	
	read(n),read(W);
	reg int x;
	for(int i=1;i<=n;++i)
	{
		read(x);
		modify(1,0,600,x,+1);
		write(kth(1,0,600,max(1,i*W/100))),lsp;
	}
	ln;
	return 0;
}
