#include <cstdio>
#include <cstring>
#include <stack>

inline int read() {
	int flag = 1, x = 0;
	char ch = getchar();
	while(ch < '0' || ch > '9')
		{ if(ch == '-') flag = -1; ch = getchar(); }
	while(ch >= '0' && ch <= '9')
		x = (x << 1) + (x << 3) + (ch ^ 48), ch = getchar();
	return x * flag;
}

const int N = 1e3 + 7;

int n, m, f[N][N], a[N][N];

inline int max(int x, int y) { return x > y ? x : y; }
inline int max(int x, int y, int z) { return max(x, max(y, z)); }

int main()
{
	freopen("number.in", "r", stdin);
//	freopen("number.out", "w", stdout);
	
	memset(f, -0x3f, sizeof(f));
	
    n = read(); m = read();
    for(int i=1; i<=n; i++)
    for(int j=1; j<=m; j++)
        a[i][j] = read();
//    for(int i=0; i<=n; i++)
//        f[i][0] = f[i][m+1] = 0;
//    for(int i=0; i<=m; i++)
//        f[0][i] = f[n+1][i] = 0;
	f[n+1][m+1] = 0;
    for(int i=n; i>=1; i--)
    for(int j=m; j>=1; j--)
        f[i][j] = max(f[i][j], f[i+1][j] + a[i][j], f[i][j+1] + a[i][j]);
    for(int i=1; i<=n; i++) {
        for(int j=1; j<=m; j++)
            printf("%d ", f[i][j]);
        puts("");
    }
    for(int i=1; i<=n; i++)
    for(int j=1; j<=m; j++)
        f[i][j] = max(f[i][j], f[i-1][j] + a[i][j], f[i][j-1] + a[i][j]);
    for(int i=1; i<=n; i++) {
        for(int j=1; j<=m; j++)
            printf("%d ", f[i][j]);
        puts("");
    }
	printf("%d", f[n][m] - a[1][1]);
}
