#include <iostream>
#include <cstdio>
#include <cstdlib>

using namespace std;

const int N = 1000 + 5;

long long dp[N][N];
int a[N][N];

int main()
{
	freopen("number.in","r",stdin);
	freopen("number.out","w",stdout);

	int n = 0, m = 0,i , j , k;
	long long t;

	scanf("%d%d",&n,&m);

	for(i = 1; i <= n; ++i)
	{
		for(j = 1; j <= m; ++j)
		{
			scanf("%d",&a[i][j]);
		}
	}

	for(i = 1; i <= n; ++i)
	{
		for(j = 1; j <= m; ++j)
		{
			dp[i][j] = -1e11;
		}
	}

	dp[1][1] = a[1][1];
	for(i = 2; i <= n; ++i)
	{
		dp[i][1] = dp[i - 1][1] + a[i][1];
	}

	for(j = 2; j < m; ++j)
	{
		for(i = 1; i <= n; ++i)
		{
			t = dp[i][j - 1];
			for(k = 0; i + k <= n; ++k)
			{
				t += a[i + k][j];
				if(t > dp[i + k][j])
				{
					dp[i + k][j] = t;
				}
			}
		}
		for(i = n; i >= 1; --i)
		{
			t = dp[i][j - 1];
			for(k = 0; i - k >= 1; ++ k)
			{
				t += a[i - k][j];
				if(t > dp[i - k][j])
				{
					dp[i - k][j] = t;
				}
			}
		}
	}
	if(m > 1)
	{
		for(i = 1; i <= n; ++i)
		{
			t = dp[i][m - 1];
			for(k = 0; i + k <= n; ++k)
			{
				t += a[i + k][m];
				if(t > dp[i + k][m])
				{
					dp[i + k][m] = t;
				}
			}
		}
	}


	printf("%lld",dp[n][m]);
	fclose(stdin);
	fclose(stdout);
	return 0;
}
