#include <iostream>
#include <cstdio>
#include <queue>
using namespace std;
typedef int ll;

struct point {
	point(int y, int x) : i(y), j(x) {
	}
	point(const point& p) : i(p.i), j(p.j) {
	}
	int i, j;
};

#define INF -11000000000

ll map[1005][1005] = { 0 };
ll num[1005][1005] = { 0 };
int upi[1005][1005] = { 0 };
int upj[1005][1005] = { 0 };
char vis[1005][1005] = { 0 };// ֵൽ3charʡռ 

//inline ll max(ll a, ll b) {
//	return a > b ? a : b;
//}

int main() {
	FILE* in, *out;
	in = fopen("number.in", "r");
	out = fopen("number.out", "w");
	int n, m;
	fscanf(in, "%d %d", &n, &m);
	for (int i = 1; i <= n; i++)
		for (int j = 1; j <= m; j++)
			fscanf(in, "%ld", &map[i][j]);
	for (int i = 1; i <= n; i++)
		for (int j = 1; j <= m; j++)
			num[i][j] = INF;
//	for (int i = 1; i <= n; i++) {
//		for (int j = 1; j <= m; j++)
//			fprintf(out, "%ld ", map[i][j]);
//		fprintf(out, "\n");
//	}
//	printf("%ld", INF);
	queue<point> q;
	q.push(point(1, 1));
	num[1][1] = map[1][1];
	while (!q.empty()) {
		point p(q.front());
		int i = p.i, j = p.j;
		q.pop();
		vis[i][j]++;
		ll mv = map[i][j];
		if (num[i - 1][j] + mv > num[i][j]) {
			num[i][j] = num[i - 1][j] + mv;
			upi[i][j] = i - 1;
		}
		if (num[i + 1][j] + mv > num[i][j]) {
			num[i][j] = num[i + 1][j] + mv;
			upi[i][j] = i + 1;
		}
		if (num[i][j - 1] + mv > num[i][j]) {
			num[i][j] = num[i][j - 1] + mv;
			upj[i][j] = j - 1;
		}
		if (i > 1 && vis[i - 1][j] < 3 && (upi[i][j] != i - 1 || upj[i][j] != j)) q.push(point(i - 1, j));
		if (j < m && vis[i][j + 1] < 3) q.push(point(i, j + 1));
		if (i < n && vis[i + 1][j] < 3 && (upi[i][j] != i + 1 || upj[i][j] != j)) q.push(point(i + 1, j));
	}
	fprintf(out, "%ld", num[n][m]);
	fclose(in);
	fclose(out);
	return 0;
}
